#!/bin/bash
#
if [ -f /etc/linkat-caf-fix ]; then
	exit 0
fi
if [ -f /etc/profile.CA ]; then
	if [ -f /etc/init.d/CA-DSM ]; then
	   if [ -z "$(grep caf\ kill\ all /etc/init.d/CA-DSM)" ]; then
	      cp /etc/init.d/CA-DSM /etc/init.d/CA-DSM.bak
	      sed -i 's/sd_jexec\ unit/\#sd_jexec\ unit/g' /etc/init.d/CA-DSM
	      sed -i '/#sd_jexec\ unit=\.\ shutdown\ >>/a\\t\t\tcaf\ kill\ all\ \>\/dev\/null 2>&1' /etc/init.d/CA-DSM 
	   fi
	fi
	if [ "$(stat -c "%a" /opt/CA/CAlib)" != "755" ]; then
	   chmod 755 /opt/CA/CAlib
	fi
	BASE_DIR_CAF=/opt/CA/SharedComponents
	for i in bin cai18n ccs lib packager;
	do
		if [ -d "$BASE_DIR_CAF/$i" ]; then
			if [ "$(stat -c "%a" "$BASE_DIR_CAF/$i")" != "755" ]; then
			   chmod 755 $BASE_DIR_CAF/$i
			fi
                fi
	done
	sleep 30
	. /etc/profile.CA all
	#
	# CA PID check
	#
	if [ -z "$(pidof -s caf)" ]; then
		#
		# Checking Network Connectivity
		#
		WAIT_TIME=5m
		FLAG=0
		TEST_IPS="educaciodigital.cat ubuntu.com wikipedia.org"
		TARGET=($(echo $TEST_IPS))
		N_TARGET=${#TARGET[@]}
		let 'N_TARGET -=1'
		TEST_PORT=443
		CURRENT_TEST_IP=0
		while [ $FLAG -eq 0 ];
		do
		TESTIP=${TARGET[$CURRENT_TEST_IP]}
		if [ -z "$(nmap  -p $TEST_PORT $TESTIP  2>/dev/null |grep open)" ]; then
			if [ $CURRENT_TEST_IP -lt $N_TARGET ]; then   
				let 'CURRENT_TEST_IP +=1'
			else
				CURRENT_TEST_IP=0
				sleep $WAIT_TIME
			fi
		else
			FLAG=1
		fi
		done
		caf restart
		sleep 5
	fi
        if [ ! -f /opt/CA/SharedComponents/ccs/cam/cam.cfg ]; then
		if [ -f /usr/share/linkat/linkat-caf-fix/cam.cfg ]; then
			cp /usr/share/linkat/linkat-caf-fix/cam.cfg /opt/CA/SharedComponents/ccs/cam/
			chmod 644 /opt/CA/SharedComponents/ccs/cam/cam.cfg
			camclose
			sleep 5
			caf restart
			sleep 5
		fi
	else
		if [ -f /usr/share/linkat/linkat-caf-fix/cam.cfg ]; then
			if [ -n "$(diff /usr/share/linkat/linkat-caf-fix/cam.cfg /opt/CA/SharedComponents/ccs/cam/cam.cfg)" ]; then
				cp /usr/share/linkat/linkat-caf-fix/cam.cfg /opt/CA/SharedComponents/ccs/cam/
				chmod 644 /opt/CA/SharedComponents/ccs/cam/cam.cfg
				camclose
				sleep 5
				caf restart
				sleep 5
			fi
		fi
        fi
	COUNTER=0
	for j in clamd freshclam caf cfsmsmd cfnotsrvd cfProcessManager cfFTPlugin hmagent
	do
	   PIDOF_CAF=$(pidof -s $j)
	   while [ -z "$(pidof -s $j)" ] && [ $COUNTER -le 6  ]; do
	      let COUNTER+=1
	      sleep 5s
	   done
	   if [ -n "$PIDOF_CAF" ]; then
		/usr/bin/renice -n 19 -p "$PIDOF_CAF"
		/usr/bin/ionice -c2 -n7 -p "$PIDOF_CAF"
	   fi
	done
fi
exit 0
